"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GoogleMapSection = void 0;
var react_1 = __importStar(require("react"));
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var api_1 = require("@react-google-maps/api");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var lottie_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/lottie"));
var auth_call_api_1 = require("../context/auth-call-api");
var util_1 = require("../util");
var GoogleMapSection = function (props) {
    var solution = (0, primeobjects_helper_ui_1.useSolution)();
    var address = props.address, zoom = props.zoom;
    var _a = (0, react_1.useState)(undefined), location = _a[0], setLocation = _a[1];
    var isLoaded = (0, api_1.useLoadScript)({
        googleMapsApiKey: solution.keys.googleMapsApiKey
    }).isLoaded;
    var _b = (0, react_1.useState)(false), loading = _b[0], setLoading = _b[1];
    (0, react_1.useEffect)(function () {
        if ((0, primeobjects_helper_util_1.isNonEmptyString)(address)) {
            setLoading(true);
            (0, auth_call_api_1.callApi)(solution, (0, util_1.getApiEndpoint)(solution, "data", "get-geo-code"), 
            //"http://localhost:3000/prod/get-geo-code",
            {
                address: address
            }, "GET")
                .then(function (result) {
                var _a;
                setLocation((_a = result === null || result === void 0 ? void 0 : result.geometry) === null || _a === void 0 ? void 0 : _a.location);
            })
                .catch(function (exception) {
                console.error(exception);
            })
                .finally(function () {
                setLoading(false);
            });
        }
    }, [address]);
    (0, react_1.useEffect)(function () {
        if (props.location)
            setLocation(props.location);
    }, [props.location]);
    return !isLoaded || loading ? (react_1.default.createElement("div", { className: "h-12 flex mx-auto my-auto" },
        react_1.default.createElement(lottie_1.default, { id: "top-cities", className: "h-full", url: "/icons/platform/lottie/dots-2.json", colors: Array(6).fill(primeobjects_helper_util_1.COLORS.GRAY[700]) }))) : !location ? (react_1.default.createElement("div", { className: "w-full h-full" })) : (react_1.default.createElement(api_1.GoogleMap, { mapContainerClassName: "w-full h-full", center: location, zoom: zoom !== null && zoom !== void 0 ? zoom : 10 },
        react_1.default.createElement(api_1.Marker, { position: location })));
};
exports.GoogleMapSection = GoogleMapSection;
exports.default = exports.GoogleMapSection;
//# sourceMappingURL=google-map.js.map