"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PageError = void 0;
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var react_1 = __importDefault(require("react"));
var svg_1 = require("primeobjects-ui-web-basic/build/cjs/controls/svg");
var colors_1 = require("primeobjects-helper-util/build/cjs/colors");
var PageError = function (props) {
    var title = props.title ? props.title : "System Error";
    var description = props.description
        ? props.description
        : "Sorry. There was a problem. Please try again later.";
    var reason = props.reason ? props.reason : "Unknown";
    var iconSrc = (0, core_1.isNonEmptyString)(props.iconSrc)
        ? props.iconSrc
        : "/icons/platform/bug.svg";
    return (react_1.default.createElement("div", { className: "flex flex-col h-screen my-auto items-center bg-cover py-10" },
        react_1.default.createElement("div", { className: "flex flex-col border border-red-200 rounded-xl p-4 m-auto" },
            react_1.default.createElement("div", { className: "flex w-full pb-2" },
                react_1.default.createElement("div", { className: "flex items-center" },
                    react_1.default.createElement(svg_1.SVG, { id: "loader_icon", src: iconSrc, color: colors_1.COLORS.RED["600"], className: "h-8 w-8", size: 50 })),
                react_1.default.createElement("div", { className: "flex-1 ml-5 " },
                    react_1.default.createElement("h1", { className: "font-semibold text-lg text-gray-800" }, title),
                    react_1.default.createElement("div", { className: "text-gray-600" }, description),
                    react_1.default.createElement("div", { className: "text-gray-600" },
                        "Reason: ",
                        reason))))));
};
exports.PageError = PageError;
exports.default = exports.PageError;
//# sourceMappingURL=error.js.map