"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.returnServerSideProps = exports.getRecordServerSideProps = exports.getBasicServerSideProps = void 0;
var lodash_1 = require("lodash");
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var util_1 = require("../util");
var nookies_1 = __importDefault(require("nookies"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var solution_1 = require("primeobjects-helper-ui/build/cjs/hooks/solution");
var getBasicServerSideProps = function (props) { return __awaiter(void 0, void 0, void 0, function () {
    var query, resolvedUrl, locales, locale, req, solutionApiEndpoint, headers, appTrack, city, country, region, countryName, regionName, latitude, longitude, metroCode, postalCode, timeZone, referer, cookies, context, host, hostSegment, domain, port, protocal, solution, apiEndpoint, serverSolution, err_1, result;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                query = props.query, resolvedUrl = props.resolvedUrl, locales = props.locales, locale = props.locale, req = props.req, solutionApiEndpoint = props.solutionApiEndpoint;
                headers = req.headers ? req.headers : {};
                appTrack = props.appTrack == true;
                (0, core_1.setAppTrack)(appTrack);
                if (appTrack) {
                    console.log({ host: req.host });
                }
                city = headers["CloudFront-Viewer-City".toLowerCase()];
                country = headers["CloudFront-Viewer-Country".toLowerCase()];
                region = headers["CloudFront-Viewer-Country-Region".toLowerCase()];
                countryName = headers["CloudFront-Viewer-Country-Name".toLowerCase()];
                regionName = headers["CloudFront-Viewer-Country-Region-Name".toLowerCase()];
                latitude = headers["CloudFront-Viewer-Latitude".toLowerCase()];
                longitude = headers["CloudFront-Viewer-Longitude".toLowerCase()];
                metroCode = headers["CloudFront-Viewer-Metro-Code".toLowerCase()];
                postalCode = headers["CloudFront-Viewer-Postal-Code".toLowerCase()];
                timeZone = headers["CloudFront-Viewer-Time-Zone".toLowerCase()];
                referer = headers["Referer".toLowerCase()];
                cookies = nookies_1.default.get(props);
                context = {
                    // headers: headers,
                    city: (0, core_1.isNonEmptyString)(city) ? city : "",
                    country: (0, core_1.isNonEmptyString)(country) ? country : "",
                    region: (0, core_1.isNonEmptyString)(region) ? region : "",
                    countryName: (0, core_1.isNonEmptyString)(countryName) ? countryName : "",
                    regionName: (0, core_1.isNonEmptyString)(regionName) ? regionName : "",
                    latitude: (0, core_1.isNonEmptyString)(latitude) ? latitude : "",
                    longitude: (0, core_1.isNonEmptyString)(longitude) ? longitude : "",
                    metroCode: (0, core_1.isNonEmptyString)(metroCode) ? metroCode : "",
                    postalCode: (0, core_1.isNonEmptyString)(postalCode) ? postalCode : "",
                    timeZone: (0, core_1.isNonEmptyString)(timeZone) ? timeZone : "",
                    referer: (0, core_1.isNonEmptyString)(referer) ? referer : ""
                };
                host = headers["x-forwarded-host"]
                    ? headers["x-forwarded-host"]
                    : headers.host;
                hostSegment = host ? host.split(":") : [];
                domain = props.domain
                    ? props.domain
                    : hostSegment.length > 0
                        ? (0, primeobjects_helper_util_1.getRootDomainFromHost)(hostSegment[0])
                        : "";
                port = headers["x-forwarded-port"]
                    ? headers["x-forwarded-port"]
                    : hostSegment.length > 1 && hostSegment[1];
                protocal = headers["x-forwarded-proto"]
                    ? headers["x-forwarded-proto"]
                    : "https";
                solution = props.solution;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                apiEndpoint = "".concat(solutionApiEndpoint, "current-solution");
                if ((0, primeobjects_helper_util_1.appTrackIsOn)()) {
                    console.log({
                        name: "getBasicServerSideProps",
                        apiEndpoint: apiEndpoint
                    });
                }
                return [4 /*yield*/, (0, util_1.callApiBase)(apiEndpoint, { domain: domain }, "GET", {
                        solutionId: primeobjects_helper_util_1.GUID_EMPTY
                    })];
            case 2:
                serverSolution = _b.sent();
                if ((_a = solution === null || solution === void 0 ? void 0 : solution.app) === null || _a === void 0 ? void 0 : _a.navigation) {
                    if (!serverSolution.app)
                        serverSolution.app = {};
                    serverSolution.app.navigation = solution.app.navigation;
                }
                if (solution === null || solution === void 0 ? void 0 : solution.apis) {
                    serverSolution.apis = solution.apis;
                }
                if (solution === null || solution === void 0 ? void 0 : solution.entities) {
                    serverSolution.entities = solution.entities;
                }
                solution = __assign(__assign({}, solution), serverSolution);
                return [3 /*break*/, 4];
            case 3:
                err_1 = _b.sent();
                console.error(err_1);
                return [3 /*break*/, 4];
            case 4:
                (0, solution_1.setSolution)(solution);
                result = {
                    query: query,
                    resolvedUrl: resolvedUrl,
                    url: "/".concat(locale).concat(resolvedUrl),
                    solution: solution,
                    locales: locales,
                    locale: locale,
                    headers: headers,
                    host: host,
                    context: context,
                    cookies: cookies,
                    domain: domain,
                    port: port,
                    appTrack: appTrack,
                    protocal: protocal
                };
                if ((0, primeobjects_helper_util_1.appTrackIsOn)()) {
                    console.log(JSON.stringify(result));
                }
                return [2 /*return*/, result];
        }
    });
}); };
exports.getBasicServerSideProps = getBasicServerSideProps;
var getRecordServerSideProps = function (basicServerSideProps, entityName, entityType, includeList, cacheExpireMinutes) { return __awaiter(void 0, void 0, void 0, function () {
    var solution, query, slug, entity, result, scope, entityName_1, cacheKey, data_1, err_2, data, record, organization;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                solution = basicServerSideProps.solution, query = basicServerSideProps.query;
                slug = query === null || query === void 0 ? void 0 : query.slug;
                entity = (0, primeobjects_helper_util_1.getEntity)(solution, entityName, entityType);
                result = {};
                scope = query.token ? "organization" : "global";
                if (!entity) return [3 /*break*/, 5];
                entityName_1 = entity.entityName;
                cacheKey = query.cache != "false" ? "read-".concat(entityName_1, "-").concat(slug, "-").concat(scope) : "";
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                data_1 = {
                    cacheExpireMinutes: !(0, lodash_1.isNil)(cacheExpireMinutes) && cacheExpireMinutes > 0
                        ? cacheExpireMinutes
                        : 60 * 24 * 365,
                    flushCache: query.flushCache == "true",
                    cacheKey: query.token ? "" : cacheKey,
                    slug: slug,
                    entityName: entityName_1,
                    recordToken: query.token,
                    needOrganizationSiteInfo: true,
                    stateCode: 0,
                    includeList: includeList,
                    query: {
                        scope: scope,
                        conditions: [
                            { attribute: "stateCode", op: ">=", value: 0 }
                        ],
                        attributes: "title,summary,slug",
                        entityName: entityName_1,
                        orderBy: [
                            {
                                attribute: "isGlobalOrderBy",
                                type: "desc"
                            }
                        ]
                    }
                };
                return [4 /*yield*/, (0, util_1.callApiBase)((0, util_1.getApiEndpoint)(solution, "data", "query-plus"), 
                    // "http://localhost:3000/prod/query-plus",
                    data_1, "POST", { solutionId: solution.id })];
            case 2:
                result = _a.sent();
                return [3 /*break*/, 4];
            case 3:
                err_2 = _a.sent();
                console.error(err_2);
                return [3 /*break*/, 4];
            case 4: return [3 /*break*/, 6];
            case 5:
                console.error("Entity is not provided.");
                _a.label = 6;
            case 6:
                data = result.data, record = result.record, organization = result.organization;
                if ((record === null || record === void 0 ? void 0 : record.stateCode) < 0)
                    record = undefined;
                return [2 /*return*/, (0, exports.returnServerSideProps)(__assign(__assign({}, basicServerSideProps), { organization: organization, data: data, record: record, entity: entity }))];
        }
    });
}); };
exports.getRecordServerSideProps = getRecordServerSideProps;
var returnServerSideProps = function (props) {
    for (var property in props) {
        if ((0, lodash_1.isNil)(props[property]))
            delete props[property];
    }
    return { props: props };
};
exports.returnServerSideProps = returnServerSideProps;
//# sourceMappingURL=server.js.map