"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkPageError = exports.handleReadModeTooltips = void 0;
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var tippy_js_1 = __importDefault(require("tippy.js"));
var handleReadModeTooltips = function (record) {
    var win = (0, primeobjects_helper_util_1.getWindow)();
    var anchors = win.document.getElementsByTagName("a");
    if (record && record.content_tooltips && !(0, primeobjects_helper_util_1.isSSR)()) {
        for (var i = 0; i < anchors.length; i++) {
            var anchor = anchors[i];
            var href = "".concat(anchor.getAttribute("href"));
            if (href.indexOf("tooltip-") >= 0) {
                var id = href.replace("tooltip-", "");
                var content = record.content_tooltips[id];
                if (content) {
                    anchor.setAttribute("id", "_".concat(id));
                    anchor.setAttribute("content", content);
                    anchor.setAttribute("href", "#");
                    anchor.setAttribute("className", "tooltip");
                    (0, tippy_js_1.default)("#_".concat(id), {
                        content: "loading ...",
                        theme: "light",
                        placement: "top",
                        arrow: false,
                        onShow: function (instance) {
                            var t = document.getElementById(instance.reference.id);
                            if (t) {
                                instance.setContent("".concat(t.getAttribute("content")));
                            }
                        },
                        allowHTML: true
                    });
                }
            }
        }
    }
};
exports.handleReadModeTooltips = handleReadModeTooltips;
var checkPageError = function (props) {
    var solution = props.solution;
    if (!solution.id)
        return "Failed to load solution profile";
    return undefined;
};
exports.checkPageError = checkPageError;
//# sourceMappingURL=util.js.map