"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NavSection = void 0;
var react_1 = __importStar(require("react"));
var lodash_1 = require("lodash");
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var primary_color_1 = require("primeobjects-helper-ui/build/cjs/hooks/primary-color");
var router_1 = require("next/router");
var use_current_context_1 = require("../../context/use-current-context");
var svg_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/svg"));
var tooltip_1 = __importDefault(require("../../controls/antd/tooltip"));
var me_1 = __importDefault(require("./me"));
var colors_1 = require("primeobjects-helper-util/build/cjs/colors");
var cookie_1 = require("primeobjects-ui-web-basic/build/cjs/util/cookie");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var gradient_div_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/gradient-div"));
var logo_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/logo"));
var env_1 = require("primeobjects-ui-web-store/build/cjs/stores/env");
var item_1 = require("./item");
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var index_1 = require("mobx-react-lite/dist/index");
exports.NavSection = (0, index_1.observer)(function (props) {
    var _a;
    var fixedSize = props.fixedSize, allowGuest = props.allowGuest;
    var solution = (_a = (0, primeobjects_helper_ui_1.useSolution)()) !== null && _a !== void 0 ? _a : props.solution;
    var _b = (0, react_1.useState)(""), navSize = _b[0], setNavSize = _b[1];
    var _c = (0, react_1.useState)(""), selectedItemId = _c[0], setSelectedItemId = _c[1];
    var copyright = solution.site.copyright;
    var year = new Date().getFullYear();
    var businessName = solution.site.businessName;
    var version = solution.version;
    var hidden = props.hidden == true;
    var context = (0, use_current_context_1.useCurrentContext)(solution, {
        componentName: "/sections/nav/index.tsx"
    });
    var envStore = (0, env_1.useEnvStore)();
    var user = context === null || context === void 0 ? void 0 : context.user;
    var isSolutionAdmin = (0, primeobjects_helper_util_1.hasRole)(context, "SOLUTION-ADMIN");
    var primaryColor = (0, primary_color_1.usePrimaryColor)(solution);
    var router = (0, router_1.useRouter)();
    var wrapperClassName = (0, core_1.isNonEmptyString)(props.wrapperClassName)
        ? props.wrapperClassName
        : "";
    var wrapperStyle = (0, core_1.isObject)(props.wrapperStyle) ? props.wrapperStyle : {};
    copyright = copyright.replace(/\[PH.YEAR\]/g, "".concat(year));
    copyright = copyright.replace(/\[PH.BUSINESSNAME\]/g, "".concat(businessName));
    var width = hidden ? 0 : navSize == "sm" ? 80 : 240;
    // const supportResize =
    //     !fixedSize && navSize != "sm" && props.supportResize == true;
    // const rgb: any = hexToRgb(COLORS.GRAY[50]);
    // const nameGradientColorRGB = rgb && { r: rgb?.r, g: rgb.g, b: rgb.b };
    (0, react_1.useEffect)(function () {
        updateNavSize((fixedSize !== null && fixedSize !== void 0 ? fixedSize : (0, cookie_1.getCookie)("nav-size") == "sm") ? "sm" : "lg");
    }, []);
    (0, react_1.useEffect)(function () {
        if (!fixedSize && envStore.width <= 768 && navSize != "sm") {
            updateNavSize("sm");
        }
        if (!fixedSize && envStore.width > 768 && navSize != "lg") {
            updateNavSize("lg");
        }
    }, [envStore.width]);
    (0, react_1.useEffect)(function () {
        var selectedItem = (0, item_1.getNavItem)(solution.app.navigation, user, allowGuest);
        if (selectedItem) {
            setSelectedItemId(selectedItem.id);
            // onClickItem(selectedItem);
            props.onClickItem && props.onClickItem(selectedItem);
        }
    }, [user]);
    var onClickMe = function () {
        props.onClickMe && props.onClickMe();
    };
    var onClickSolution = function () {
        props.onClickSolution && props.onClickSolution();
    };
    var onClickItem = function (item) {
        setSelectedItemId(item.id);
        if ((0, core_1.isNonEmptyString)(item.src)) {
            router.push(item.src, undefined, { shallow: true });
        }
    };
    var onClickToggleNavSize = function () {
        updateNavSize(navSize == "sm" ? "lg" : "sm", true);
    };
    var updateNavSize = function (size, manual) {
        var manualSize = (0, cookie_1.getCookie)("nav-size");
        if (!manual && manualSize == "sm") {
            //no auto resize
            setNavSize("sm");
            return props.onResize && props.onResize(80, "sm");
        }
        else {
            if (manual) {
                (0, cookie_1.setCookie)("nav-size", size);
            }
            setNavSize(size);
            props.onResize && props.onResize(size == "sm" ? 80 : 220, size);
        }
    };
    var onClickLogo = function () {
        if (props.onClickLogo) {
            return props.onClickLogo();
        }
        else {
            (0, primeobjects_helper_util_1.getWindow)().open("/");
        }
    };
    var renderSection = function (title) {
        return (react_1.default.createElement(gradient_div_1.default
        // gradientColorRGB={{ r: 248, g: 250, b: 252 }}
        , { 
            // gradientColorRGB={{ r: 248, g: 250, b: 252 }}
            className: "uppercase relative py-2 mt-4 text-xs text-gray-500 leading-none ".concat(navSize == "sm" ? "justify-center" : "px-4"), style: { minHeight: "2rem" } }, title));
    };
    var renderItems = function (items) {
        return (0, lodash_1.filter)((0, lodash_1.map)(items, function (item, index) {
            if (!(0, item_1.checkNavRole)(item, user) || item.hidden == true) {
                return null;
            }
            switch (item.id) {
                case "platform": {
                    return renderPlatformInfo();
                }
                case "solution": {
                    return (isSolutionAdmin && (react_1.default.createElement(item_1.NavSectionItem, { key: index, item: {
                            id: "solution",
                            title: "Solution Settings",
                            icon: "/icons/platform/solution.svg",
                            src: ""
                        }, color: primaryColor, onClickItem: onClickSolution, navSize: navSize })));
                }
                case "me": {
                    return (react_1.default.createElement("div", { className: "p-3" },
                        react_1.default.createElement(me_1.default, { showName: navSize != "sm", onClick: onClickMe, size: 30 })));
                }
                default: {
                    return (react_1.default.createElement(item_1.NavSectionItem, { key: index, item: item, color: primaryColor, selected: selectedItemId == item.id, onClickItem: onClickItem, navSize: navSize }));
                }
            }
        }), function (item) { return !(0, lodash_1.isNil)(item); });
    };
    var renderNavigation = function () {
        return (0, lodash_1.map)(solution.app.navigation, function (nav, index) {
            if (!(0, item_1.checkNavRole)(nav, user) || nav.hidden == true) {
                return null;
            }
            return (react_1.default.createElement(react_1.default.Fragment, { key: index },
                nav.title && renderSection(nav.title),
                renderItems(nav.items)));
        });
    };
    var renderPlatformInfo = function () {
        return (react_1.default.createElement("div", { className: "w-full px-2 py-1 flex flex-row items-center" },
            react_1.default.createElement("div", { className: "relative flex flex-row w-full p-3 rounded hover:shadow ".concat(navSize == "sm" ? "flex-row justify-center" : "flex-col") },
                react_1.default.createElement("div", { className: navSize == "sm" ? "" : "mr-4" },
                    react_1.default.createElement(logo_1.default, { color: "black", onClick: onClickLogo, logoSrc: "/logo.svg", logoSize: 28, text: navSize != "sm" ? copyright : undefined, textStyle: {
                            fontSize: 11,
                            fontWeight: 500,
                            marginLeft: navSize == "sm" ? 0 : 5
                        } })),
                navSize != "sm" && (react_1.default.createElement(tooltip_1.default, { title: "VER: ".concat(version), color: primaryColor["400"], placement: "right" },
                    react_1.default.createElement("div", { className: "cursor-pointer", style: {
                            position: "absolute",
                            right: 10,
                            top: 20
                        } },
                        react_1.default.createElement(svg_1.default, { src: "/icons/platform/info.svg", size: 16, color: colors_1.COLORS.GRAY["800"] })))))));
    };
    return (react_1.default.createElement("nav", { className: "relative flex flex-col overflow-hidden overflow-y-auto py-4 ".concat(wrapperClassName), style: __assign({ height: envStore.height - 65, width: width, minWidth: width }, wrapperStyle) },
        react_1.default.createElement("div", { className: "shadow cursor-pointer bg-white rounded-full sticky hover:shadow-lg", style: {
                left: 4,
                top: -12,
                marginTop: -12,
                width: 18,
                height: 18
            } },
            react_1.default.createElement(svg_1.default, { onClick: onClickToggleNavSize, color: primaryColor["600"], src: navSize == "sm"
                    ? "/icons/platform/circled-right.svg"
                    : "/icons/platform/circled-left.svg", size: 18 })),
        renderNavigation()));
});
exports.default = exports.NavSection;
//# sourceMappingURL=index.js.map