//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import React from "react";
import { isNonEmptyString, isObject } from "primeobjects-helper-util/build/cjs/core";
import { map } from "lodash";
import SVG from "primeobjects-ui-web-basic/build/cjs/controls/svg";
import { usePrimaryColorName } from "primeobjects-helper-ui/build/cjs/hooks/primary-color";
import { getWindow } from "primeobjects-helper-util/build/cjs/core";
export var SiteBreadcrumbSection = function (props) {
    var pages = props.pages, solution = props.solution;
    var primaryColorName = usePrimaryColorName(solution);
    var className = isNonEmptyString(props.className) ? props.className : "";
    var style = isObject(props.style) ? props.style : {};
    var onClick = function (page) {
        page.url &&
            isNonEmptyString(page.url) &&
            getWindow().location.replace(page.url);
    };
    return (React.createElement("div", { className: "flex w-full ".concat(className, " border-t mt-2 pt-2 border-dashed"), style: style },
        map(pages, function (page, index) {
            return (React.createElement("div", { key: index, className: "flex content-center items-center" },
                index > 0 && (React.createElement(SVG, { src: "/icons/platform/forward.svg", size: 10, className: index == 0 ? "mr-2" : "mx-2" })),
                React.createElement("a", { className: "flex w-full text-sm content-center items-center text-gray-600 ".concat(isNonEmptyString(page.url)
                        ? "hover:text-".concat(primaryColorName, "-600 cursor-pointer")
                        : ""), onClick: function () {
                        onClick(page);
                    } }, page.title)));
        }),
        React.createElement("div", { className: "flex-1" })));
};
export default SiteBreadcrumbSection;
//# sourceMappingURL=site-breadcrumb.js.map