//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import React from "react";
import SiteSection from "./site-section";
import { usePrimaryColor } from "primeobjects-helper-ui";
export var SiteErrorSection = function (props) {
    var primaryColor = usePrimaryColor();
    var code = props.code ? props.code : "404";
    var title = props.title ? props.title : "Page not found";
    var message = props.message
        ? props.message
        : "Sorry, something has gone wrong.";
    var goBackText = props.goBackText ? props.goBackText : "Go back home";
    var goBackUrl = props.goBackUrl ? props.goBackUrl : "/";
    return (React.createElement(SiteSection, { className: "relative" },
        React.createElement("div", { className: "max-w-7xl mx-auto flex flex-row" },
            React.createElement("div", { className: "my-auto flex-shrink-0 py-16 sm:py-32" },
                React.createElement("p", { className: "text-2xl font-bold text-".concat(primaryColor.name, "-600") }, code),
                React.createElement("h1", { className: "mt-4 text-4xl font-bold tracking-tight text-gray-900 sm:text-5xl" }, title),
                React.createElement("p", { className: "mt-4 text-base text-gray-600" }, message),
                props.reason && (React.createElement("p", { className: "text-base text-red-600" }, props.reason)),
                React.createElement("div", { className: "mt-6" },
                    React.createElement("a", { href: "/".concat(goBackUrl), className: "text-base font-medium text-".concat(primaryColor.name, "-600 hover:text-").concat(primaryColor.name, "-700") }, goBackText))))));
};
export default SiteErrorSection;
//# sourceMappingURL=site-error.js.map